ALTER FUNCTION [dbo].[Func_TA_MusterRoll_OD_Notation] 
(
	@Date DATETIME,
	@AttendanceCode NVARCHAR(50),
	@EmployeeCodeId NVARCHAR(15),
	@AttendType NVARCHAR(2),
	@ShiftId INT,
	@ReplaceText NVARCHAR(50)
)
RETURNS NVARCHAR(15)
AS
BEGIN	
	DECLARE @RecCount INT
	DECLARE @OnDutyText NVARCHAR(15), @ShiftStartTime NVARCHAR(20), @Shift_SecondHalf_Starttime NVARCHAR(20), @ShiftEndtime NVARCHAR(20)
	IF(@ShiftId = -1)
		SELECT @ShiftId = PD.Shift_Id FROM TA_Tbl_ProcessedData PD WHERE PD.[Date] = DATEADD(D, -1, @Date) AND PD.Employee_Code_Id = @EmployeeCodeId
	IF(@ShiftId = -1)
		SELECT @ShiftId = PD.Shift_Id FROM TA_Tbl_ProcessedData PD WHERE PD.[Date] = DATEADD(D, -2, @Date) AND PD.Employee_Code_Id = @EmployeeCodeId
	IF(EXISTS (SELECT S.Shift_EndTime FROM TA_Tbl_Shift S WHERE S.Shift_Id = @ShiftId))
		SELECT @ShiftStartTime = S.Shift_StartTime, @Shift_SecondHalf_Starttime = S.Shift_SecondHalf_StartTime, @ShiftEndtime = S.Shift_EndTime FROM TA_Tbl_Shift S WHERE S.Shift_Id = @ShiftId
	SET @OnDutyText = @ReplaceText
	IF((CHARINDEX('PM', @ShiftStartTime) > 0) AND (CHARINDEX('AM', @ShiftEndtime) > 0))
	BEGIN
		IF(CHARINDEX('AM', @Shift_SecondHalf_Starttime)>0)
		BEGIN
			IF(@AttendType = 'FN')
			BEGIN
				SELECT @RecCount = COUNT(MTE.IsOnDuty) FROM TA_Tbl_ManualTimeEntry MTE
				WHERE MTE.ManualTimeEntry_InDate = @Date
								and 
								(
									cast(ManualTimeEntry_InTime as datetime) < (dateadd(dd,1,cast(@Shift_SecondHalf_Starttime as datetime)))
									or
									cast(ManualTimeEntry_OutTime as datetime) < (dateadd(dd,1,cast(@Shift_SecondHalf_Starttime as datetime)))
								)
								and IsOnDuty=1 and ManualTimeEntry_Employee_Id=@EmployeeCodeId and IsDeleted=0 and ManualTimeEntry_Status='Approved'
						end
					else
						begin
							set @RecCount=
							(
								select count(IsOnDuty) from TA_Tbl_ManualTimeEntry 
								where ManualTimeEntry_OutDate = case when ((CHARINDEX('PM',ManualTimeEntry_InTime)>0) and (CHARINDEX('AM',ManualTimeEntry_OutTime)>0)) then dateadd(dd,1,@Date) else @Date end
								and 
								(
									cast(ManualTimeEntry_InTime as datetime) > cast(@Shift_SecondHalf_Starttime as datetime)
									or
									cast(ManualTimeEntry_OutTime as datetime) > cast(@Shift_SecondHalf_Starttime as datetime)
								)
								and IsOnDuty=1 and ManualTimeEntry_Employee_Id=@EmployeeCodeId and IsDeleted=0 and ManualTimeEntry_Status='Approved'
							)
						end
				End
			else if(CHARINDEX('PM',@Shift_SecondHalf_Starttime)>0)
				Begin
					if(@AttendType='FN')
						begin
							set @RecCount=
							(
								select count(IsOnDuty) from TA_Tbl_ManualTimeEntry where ManualTimeEntry_InDate = @Date			
								and 
								(
									cast(ManualTimeEntry_InTime as datetime) < cast(@Shift_SecondHalf_Starttime as datetime)
									or
									case when CHARINDEX('AM',ManualTimeEntry_OutTime)>0 then
														dateadd(dd,1,cast(ManualTimeEntry_OutTime as datetime)) else cast(ManualTimeEntry_OutTime as datetime) end < cast(@Shift_SecondHalf_Starttime as datetime)
								)
								and IsOnDuty=1 and ManualTimeEntry_Employee_Id=@EmployeeCodeId and IsDeleted=0 and ManualTimeEntry_Status='Approved'
							)
						end
			else
				begin
						set @RecCount=
						(
							select count(IsOnDuty) from TA_Tbl_ManualTimeEntry 
							where ManualTimeEntry_OutDate = case when ((CHARINDEX('PM',ManualTimeEntry_InTime)>0) and (CHARINDEX('AM',ManualTimeEntry_OutTime)>0)) then dateadd(dd,1,@Date) else @Date end
							and 
							(
								cast(ManualTimeEntry_InTime as datetime) > cast(@Shift_SecondHalf_Starttime as datetime)
								or
								case when CHARINDEX('AM',ManualTimeEntry_OutTime)>0 then
								(dateadd(dd,1,cast(ManualTimeEntry_OutTime as datetime))) else (cast(ManualTimeEntry_OutTime as datetime)) end  > cast(@Shift_SecondHalf_Starttime as datetime)
							)
							and IsOnDuty=1 and ManualTimeEntry_Employee_Id=@EmployeeCodeId and IsDeleted=0 and ManualTimeEntry_Status='Approved'
						)
				end
		End
End
else
Begin
	if(@AttendType='FN')
	begin
		set @RecCount=(select count(IsOnDuty) from TA_Tbl_ManualTimeEntry 
		where ManualTimeEntry_InDate = @Date
		and 
		(
		cast(ManualTimeEntry_InTime as datetime) < @Shift_SecondHalf_Starttime
		or
		cast(ManualTimeEntry_OutTime as datetime) < @Shift_SecondHalf_Starttime
		)
		and IsOnDuty=1
		and ManualTimeEntry_Employee_Id=@EmployeeCodeId
		and IsDeleted=0
		and ManualTimeEntry_Status='Approved'
		)
	end
	else
	begin
		set @RecCount=(select count(IsOnDuty) from TA_Tbl_ManualTimeEntry 
		where ManualTimeEntry_OutDate = @Date
		and 
		(
		cast(ManualTimeEntry_InTime as datetime) > @Shift_SecondHalf_Starttime
		or
		cast(ManualTimeEntry_OutTime as datetime) > @Shift_SecondHalf_Starttime
		)
		and IsOnDuty=1
		and ManualTimeEntry_Employee_Id=@EmployeeCodeId
		and IsDeleted=0
		and ManualTimeEntry_Status='Approved'
		)
	end
End
if(@RecCount>0)
begin
	if(@AttendanceCode='Present' or @AttendanceCode='Weekly Off' or @AttendanceCode='Holiday')
	begin

	declare @ValidationWFH int
		Select @ValidationWFH=TA_Tbl_OndutyEntry.On_WFH from TA_Tbl_ManualTimeEntry
		Inner Join TA_Tbl_OndutyEntry on TA_Tbl_OndutyEntry.Onduty_ID = TA_Tbl_ManualTimeEntry.OnDuty_ID
		where  @Date  between ManualTimeEntry_InDate and ManualTimeEntry_OutDate

		if(@ValidationWFH =0)
		begin
		set @OnDutyText='OD'
		end
		else if(@ValidationWFH =1)
		begin
		set @OnDutyText='PM'
		end 
		else if(@ValidationWFH =2)
		begin
		set @OnDutyText='PP'
		end 




		--set @OnDutyText='OD'
	End
	--if(@AttendanceCode='Present' or @AttendanceCode='Weekly Off' or @AttendanceCode='Holiday')
	--begin
	--	set @OnDutyText='OD'
	--End
end
RETURN @OnDutyText
END

-- ----------------------------------
Go
ALTER FUNCTION [dbo].[Func_TA_OnDuty] 
(
	@Date as datetime,
	@AttendanceCode as varchar(50),
	@EmployeeCodeId as nvarchar(15),
	@AttendType as varchar(2),
	@ShiftStartTime varchar(20),
	@Shift_SecondHalf_Starttime varchar(20),
	@ShiftEndtime varchar(20),
	@isFlexible int,
	@Shiftid int,
	@TotWrkHrs varchar(10)
)
RETURNS varchar(15)
AS
BEGIN	
	declare @recCount as int
	declare @OnDutyText as varchar(15)
	set @OnDutyText=''
	if((charindex('PM',@ShiftStartTime) > 0) and (charindex('AM',@ShiftEndtime) > 0))
		Begin
			if(charindex('AM',@Shift_SecondHalf_Starttime)>0)
				Begin
					if(@AttendType='FN')
						begin
							set @recCount=
							(
								select count(*) from TA_Tbl_ManualTimeEntry where ManualTimeEntry_InDate = @Date
								and 
								(
									cast(ManualTimeEntry_InTime as datetime) < (dateadd(dd,1,cast(@Shift_SecondHalf_Starttime as datetime)))
									or
									cast(ManualTimeEntry_OutTime as datetime) < (dateadd(dd,1,cast(@Shift_SecondHalf_Starttime as datetime)))
								)
								and IsOnDuty=1 and ManualTimeEntry_Employee_Id=@EmployeeCodeId and IsDeleted=0 and ManualTimeEntry_Status='Approved'
							)
						end
					else
						begin
							set @recCount=
							(
								select count(*) from TA_Tbl_ManualTimeEntry 
								where ManualTimeEntry_OutDate = case when ((charindex('PM',ManualTimeEntry_InTime)>0) and (charindex('AM',ManualTimeEntry_OutTime)>0)) then dateadd(dd,1,@Date) else @Date end
								and 
								(
									cast(ManualTimeEntry_InTime as datetime) > cast(@Shift_SecondHalf_Starttime as datetime)
									or
									cast(ManualTimeEntry_OutTime as datetime) > cast(@Shift_SecondHalf_Starttime as datetime)
								)
								and IsOnDuty=1 and ManualTimeEntry_Employee_Id=@EmployeeCodeId and IsDeleted=0 and ManualTimeEntry_Status='Approved'
							)
						end
				End
			else if(charindex('PM',@Shift_SecondHalf_Starttime)>0)
				Begin
					if(@AttendType='FN')
						begin
							set @recCount=
							(
								select count(*) from TA_Tbl_ManualTimeEntry where ManualTimeEntry_InDate = @Date			
								and 
								(
									cast(ManualTimeEntry_InTime as datetime) < cast(@Shift_SecondHalf_Starttime as datetime)
									or
									case when charindex('AM',ManualTimeEntry_OutTime)>0 then
														dateadd(dd,1,cast(ManualTimeEntry_OutTime as datetime)) else cast(ManualTimeEntry_OutTime as datetime) end < cast(@Shift_SecondHalf_Starttime as datetime)
								)
								and IsOnDuty=1 and ManualTimeEntry_Employee_Id=@EmployeeCodeId and IsDeleted=0 and ManualTimeEntry_Status='Approved'
							)
						end
			else
				begin
						set @recCount=
						(
							select count(*) from TA_Tbl_ManualTimeEntry 
							where ManualTimeEntry_OutDate = case when ((charindex('PM',ManualTimeEntry_InTime)>0) and (charindex('AM',ManualTimeEntry_OutTime)>0)) then dateadd(dd,1,@Date) else @Date end
							and 
							(
								cast(ManualTimeEntry_InTime as datetime) > cast(@Shift_SecondHalf_Starttime as datetime)
								or
								case when charindex('AM',ManualTimeEntry_OutTime)>0 then
								(dateadd(dd,1,cast(ManualTimeEntry_OutTime as datetime))) else (cast(ManualTimeEntry_OutTime as datetime)) end  > cast(@Shift_SecondHalf_Starttime as datetime)
							)
							and IsOnDuty=1 and ManualTimeEntry_Employee_Id=@EmployeeCodeId and IsDeleted=0 and ManualTimeEntry_Status='Approved'
						)
				end
		End
End
else
Begin
	if(@AttendType='FN')
	begin
		set @recCount=(select count(*) from TA_Tbl_ManualTimeEntry 
		where ManualTimeEntry_InDate = @Date
		and 
		(
		cast(ManualTimeEntry_InTime as datetime) < @Shift_SecondHalf_Starttime
		or
		cast(ManualTimeEntry_OutTime as datetime) < @Shift_SecondHalf_Starttime
		)
		and IsOnDuty=1
		and ManualTimeEntry_Employee_Id=@EmployeeCodeId
		and IsDeleted=0
		and ManualTimeEntry_Status='Approved'
		)
	end
	else
	begin
		set @recCount=(select count(*) from TA_Tbl_ManualTimeEntry 
		where ManualTimeEntry_OutDate = @Date
		and 
		(
		cast(ManualTimeEntry_InTime as datetime) > @Shift_SecondHalf_Starttime
		or
		cast(ManualTimeEntry_OutTime as datetime) > @Shift_SecondHalf_Starttime
		)
		and IsOnDuty=1
		and ManualTimeEntry_Employee_Id=@EmployeeCodeId
		and IsDeleted=0
		and ManualTimeEntry_Status='Approved'
		)
	end
End
		if(@isFlexible=1)
			begin
				Declare @Count int
				select @count=count(*) from TA_Tbl_ManualTimeEntry 
				where ManualTimeEntry_OutDate = @Date and IsOnDuty=1
				and ManualTimeEntry_Employee_Id=@EmployeeCodeId
				and IsDeleted=0 and ManualTimeEntry_Status='Approved'
				if @count=0
					begin						
						if(substring(@ShiftStartTime,7,8)='PM' and substring(@ShiftEndtime,7,8)='AM')
						begin
							select @count=count(*) from TA_Tbl_ManualTimeEntry 
							where ManualTimeEntry_OutDate =dateadd(d,1, @Date)and IsOnDuty=1
							and ManualTimeEntry_Employee_Id=@EmployeeCodeId
							and IsDeleted=0 and ManualTimeEntry_Status='Approved'
						end
					end
				if(@Count>0)
				begin
					Declare @FHTotHrs varchar(20)
					Declare @SHTotHrs varchar(20)
					select @FHTotHrs= Shift_FirstHalfWorkingHours,@SHTotHrs=Shift_SecondHalfWorkingHours from TA_Tbl_Shift where Shift_Id=@Shiftid and Isdeleted=0
					if(@AttendType='FN')
					begin
						if(@TotWrkHrs<>'00:00' and convert(datetime,@TotWrkHrs)>=convert(datetime,@FHTotHrs))
							begin
								set @recCount=1
							end
					end
					if(@AttendType='AN')
					begin
						if(@TotWrkHrs<>'00:00' and CONVERT(datetime,@TotWrkHrs)>=convert(datetime,@SHTotHrs))
							begin
								set @recCount=1
							end
					end
				end
			end
			if(@recCount>0)
begin
	if(@AttendanceCode='Present' or @AttendanceCode='Weekly Off' or @AttendanceCode='Holiday')
	begin
	

		declare @ValidationWFH int
		Select @ValidationWFH=TA_Tbl_OndutyEntry.On_WFH from TA_Tbl_ManualTimeEntry
		Inner Join TA_Tbl_OndutyEntry on TA_Tbl_OndutyEntry.Onduty_ID = TA_Tbl_ManualTimeEntry.OnDuty_ID
		where  @Date  between ManualTimeEntry_InDate and ManualTimeEntry_OutDate

		if(@ValidationWFH =0)
		begin
		set @OnDutyText=' (On Duty) '
		end
		else if(@ValidationWFH =1)
		begin
		set @OnDutyText=' (PM-WFH) '
		end 
		else if(@ValidationWFH =2)
		begin
		set @OnDutyText=' (PP-WFH) '
		end 



	End
	
end
--if(@recCount>0)
--begin
--	if(@AttendanceCode='Present' or @AttendanceCode='Weekly Off' or @AttendanceCode='Holiday')
--	begin
--		set @OnDutyText=' (On Duty) '
--	End
--end
RETURN @OnDutyText
END


-----------------------------------

GO
/****** Object:  StoredProcedure [dbo].[Proc_TA_RptMonthlyAttendance]    Script Date: 31-12-2024 18:22:05 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
/*    
Proc_TA_RptMonthlyAttendance @MINWORKHOURS=N'',@FROMDAT='2020-01-01 00:00:00',@TODAT='2020-07-30 00:00:00',
@EMPLOYEENAME=N'',@LEVELID=N'',@EMPLOYEEID=N'',@EMPLOYEECATEGORY=0,@EMPLOYEETYPE=0,@USERGROUPNAME=N'SUPERADMIN',
@GRADELEVEL=N'',@EMPSWIPECARD=N'',@PARENTID=0,@DESIGNATIONID=0,@GENDER=N'both',@SHIFT=2,@DATALOADING=0,@EMPAUTOID=2,@EXPORT=7

exec Proc_TA_RptMonthlyAttendance @MinWorkHours=N'',@fromDat='2024-05-01 00:00:00',@ToDat='2024-05-30 00:00:00',@EmployeeName=N'',@LevelID=N'1',@EmployeeId=N'TC1001',@employeeCategory=0,@employeeType=0,@UserGroupName=N'SuperAdmin',@GradeLevel=N'0',@EmpSwipeCard=N'',@ParentId=1,@DesignationID=0,@Gender=N'Both',@Shift=0,@DataLoading=0,@EmpAutoId=0,@Export=0
*/
ALTER  PROCEDURE [dbo].[Proc_TA_RptMonthlyAttendance]
(   
	@MINWORKHOURS AS NVARCHAR(10)=null,
	@FROMDAT DATETIME=null,
	@TODAT DATETIME=null,
	@EMPLOYEENAME NVARCHAR(MAX)=null,
	@LEVELID NVARCHAR(MAX)=null,
	@EMPLOYEEID NVARCHAR(MAX)=null,
	@EMPLOYEECATEGORY INT=null,
	@EMPLOYEETYPE INT=0,
	@USERGROUPNAME NVARCHAR(250)=null,
	@GRADELEVEL NVARCHAR(20)=null,
	@EMPSWIPECARD NVARCHAR(20)=null,
	@PARENTID INT=0,
	@DESIGNATIONID INT=0,
	@GENDER NVARCHAR(10)=null,
	@SHIFT INT=0,
	@DATALOADING INT=0,
	@EMPAUTOID BIGINT=0,
	@EXPORT INT=0
)   
AS    
BEGIN    
	
--	DECLARE @InputDate NVARCHAR(50) = @FROMDAT
--	DECLARE @InputDates NVARCHAR(50) = @TODAT
--	DECLARE @DateInDateTime DATETIME
--	DECLARE @DateInDateTimes DATETIME

---- Convert the input string to datetime
--	SET @DateInDateTime = CONVERT(DATETIME, @InputDate, 120)
--	SET @DateInDateTimes = CONVERT(DATETIME, @InputDates, 120)
---- Convert the datetime to the desired format
--	Set @FROMDAT= CONVERT(NVARCHAR(10), @DateInDateTime, 23)
--	Set @TODAT= CONVERT(NVARCHAR(10), @DateInDateTimes, 23)
--	print @FROMDAT
--	Print @TODAT


	SET NOCOUNT ON;
	DECLARE @local_MINWORKHOURS AS NVARCHAR(10)
	DECLARE @local_FROMDAT DATETIME
	DECLARE @local_TODAT DATETIME
	DECLARE @local_EMPLOYEENAME NVARCHAR(MAX)
	DECLARE @local_LEVELID NVARCHAR(MAX)
	DECLARE @local_EMPLOYEEID NVARCHAR(MAX)
	DECLARE @local_EMPLOYEECATEGORY INT
	DECLARE @local_EMPLOYEETYPE INT
	DECLARE @local_USERGROUPNAME NVARCHAR(250)
	DECLARE @local_GRADELEVEL NVARCHAR(20)
	DECLARE @local_EMPSWIPECARD NVARCHAR(20)
	DECLARE @local_PARENTID INT
	DECLARE @local_DESIGNATIONID INT
	DECLARE @local_GENDER NVARCHAR(10)
	DECLARE @local_SHIFT INT
	DECLARE @local_DATALOADING INT
	DECLARE @local_EMPAUTOID BIGINT
	DECLARE @local_EXPORT INT
	SET @local_MINWORKHOURS		= LTRIM(RTRIM(@MINWORKHOURS))
    SET @local_FROMDAT			= LTRIM(RTRIM(@FROMDAT))
    SET @local_TODAT			= LTRIM(RTRIM(@TODAT))
    SET @local_EMPLOYEENAME		= LTRIM(RTRIM(@EMPLOYEENAME))
    SET @local_LEVELID			= LTRIM(RTRIM(@LEVELID))
    SET @local_EMPLOYEEID		= LTRIM(RTRIM(@EMPLOYEEID))    
    SET @local_EMPLOYEECATEGORY	= LTRIM(RTRIM(@EMPLOYEECATEGORY))
    SET @local_EMPLOYEETYPE     = LTRIM(RTRIM(@EMPLOYEETYPE))
    SET @local_USERGROUPNAME    = LTRIM(RTRIM(@USERGROUPNAME))
    SET @local_GRADELEVEL		= LTRIM(RTRIM(@GRADELEVEL))
    SET @local_EMPSWIPECARD		= LTRIM(RTRIM(@EMPSWIPECARD))
    SET @local_PARENTID			= LTRIM(RTRIM(@PARENTID))    
    SET @local_DESIGNATIONID	= LTRIM(RTRIM(@DESIGNATIONID))
    SET @local_GENDER			= LTRIM(RTRIM(@GENDER))
    SET @local_SHIFT			= LTRIM(RTRIM(@SHIFT))
    SET @local_DATALOADING		= LTRIM(RTRIM(@DATALOADING))
    SET @local_EMPAUTOID		= LTRIM(RTRIM(@EMPAUTOID))
    SET @local_EXPORT			= LTRIM(RTRIM(@EXPORT)) 
     
	DECLARE @SQLTEMPPROCESSEDDATA	VARCHAR(8000)
	DECLARE @SQLTEMPPROCESSEDDATA1	VARCHAR(8000)
	DECLARE @SQLEMPLEVEL			NVARCHAR(4000)
	CREATE TABLE #EMPLOYEEIDS(EMPAUTOID INT)
	CREATE TABLE #TEMPEMPLOYEE(EMPAUTOID BIGINT,EMPSWIPECARDNO VARCHAR(20))		
	CREATE TABLE #EMPLEVEL
	(
		EMPLOYEEID INT,
		LEVELID INT,
		EFFECTIVEDATE DATETIME,
		EMPLOYEE_CODE_ID VARCHAR(50),
		SWIPECARD VARCHAR(50)
	)
	CREATE TABLE #EMPDESIGNATION
	(
		EMPLOYEEID INT,
		DESIGNATIONID INT,
		EFFECTIVEDATE DATETIME,
		EMPLOYEE_CODE_ID VARCHAR(50),
		SWIPECARD VARCHAR(50)
	)
	CREATE TABLE #EMPTYPE(EMPLOYEEID INT,TYPEID INT,EFFECTIVEDATE DATETIME,EMPLOYEE_CODE_ID VARCHAR(50),SWIPECARD VARCHAR(50))
	CREATE TABLE #EMPCATEGORY(EMPLOYEEID INT,CATEGORYID INT,EFFECTIVEDATE DATETIME,EMPLOYEE_CODE_ID VARCHAR(50),SWIPECARD VARCHAR(50))
	CREATE TABLE #EMPPROCESSEDDATA(SWIPECARDNO VARCHAR(50),PROCESSDATE DATETIME,TOTALWORKMINS VARCHAR(50))    
	CREATE TABLE #LEVELRIGHTS(LEVELID INT)
	CREATE TABLE #TEMPPROCESSEDDATA
	(
		EMPAUTOID BIGINT,
		DATE DATETIME,
		EMPLOYEE_CODE_ID VARCHAR(20),
		INTIME NVARCHAR(25),
		OUTTIME NVARCHAR(25),
		SHIFT_ID INT,
		HRSWORK NVARCHAR(10),
		SUPPOSEDWORKHOURS NVARCHAR(10),
		STATUS NVARCHAR(50),
		ATTENDANCE NVARCHAR(20),
		ANATTENDANCECODE NVARCHAR(15),
		FNATTENDANCECODE NVARCHAR(15),
		PREVSHIFT_ID INT,
		PROCESS_REC_ID BIGINT,
		EXACTSHIFT_STARTTIME NVARCHAR(25),
		SHIFT_SECONDHALF_STARTTIME DATETIME,
		LATEINMIN	NVARCHAR(10),
		EARLYOUT NVARCHAR(10),
		LATEIN NVARCHAR(10),
		NORMOT NVARCHAR(10),
		OFFOT NVARCHAR(10),
		HOLOT NVARCHAR(10),
		OTMINS decimal(18,0),
		EARLYOUTMIN INT,
		OVERTIMESTATUS VARCHAR(20),
		NIGHTORMORN INT
		,INNOTATION CHAR(1),
		OUTNOTATION CHAR(1),
		BREAKHOURS VARCHAR(20),
		LUNCHHOURS VARCHAR(20),
		BREAKHOURSMINS INT,
		LUNCHHOURSMINS INT,
		ActNormOTmins int,
		ActNormOTHrs varchar(5),
		-----
		SPEC_NormOT1	varchar(10),
		SPEC_NormOTMins1	int,
		SPEC_NormOT2	varchar(10),
		SPEC_NormOTMins2	int,
		SPEC_OffOT1		varchar(10),
		SPEC_OffOTMins1	int,
		SPEC_OffOT2		varchar(10),
		SPEC_OffOTMins2	int,
		SPEC_HOLOT1		varchar(10),
		SPEC_HOLOTMins1	int,
		SPEC_HOLOT2		varchar(10),
		SPEC_HOLOTMins2	int,			
		Modified_Spec_NormOTMins1 int,
		Modified_Spec_NormOTMins2 int,
		Modified_Spec_OffOTMins1 int,
		Modified_Spec_OffOTMins2 int,
		Modified_Spec_HolOTMins1 int,
		Modified_Spec_HolOTMins2 int,
		Modified_Spec_NormOTHrs1 varchar(10),
		Modified_Spec_NormOTHrs2 varchar(10),
		Modified_Spec_OffOTHrs1 varchar(10),
		Modified_Spec_OffOTHrs2 varchar(10),
		Modified_Spec_HolOTHrs1 varchar(10),
		Modified_Spec_HolOTHrs2 varchar(10),
		InLocation varchar(500),
		OutLocation varchar(500),
		InLatitude varchar(20),
		InLongitude varchar(20),
		OutLatitude varchar(20),
		OutLongitude varchar(20)
	)
	DECLARE @ISREPORTINGTO AS INT
	DECLARE @ISINDIVIDUAL AS INT
	if(@local_USERGROUPNAME!='Superadmin')
	BEGIN
		SELECT @ISREPORTINGTO=REPORTSBASEDON,@ISINDIVIDUAL=INDIVIDUALUSERS FROM TA_TBL_USERGROUP WHERE GROUPNAME=@local_USERGROUPNAME
		INSERT INTO #EMPLOYEEIDS SELECT * FROM [DBO].[FN_TA_GETMAPPEDEMPLOYEES_REPORTINGTO](@local_EMPAUTOID) AS EMPAUTOID  
		INSERT INTO #EMPLOYEEIDS SELECT * FROM [DBO].[FN_TA_GETMAPPEDEMPLOYEES_SANCAUTHORITY](@local_EMPAUTOID) AS EMPAUTOID
	END
    INSERT INTO #LEVELRIGHTS SELECT * FROM [DBO].[FN_TA_GETPARENTCHILD](@local_USERGROUPNAME,@local_PARENTID) AS LEVELID  
	INSERT INTO #EMPDESIGNATION EXEC PROC_TA_EMPDESIGNATION @local_TODAT,@local_EMPLOYEEID,@local_DESIGNATIONID
	INSERT INTO #EMPTYPE EXEC [PROC_TA_EMPTYPE] @local_TODAT,@local_EMPLOYEEID,@local_EMPLOYEETYPE
	INSERT INTO #EMPCATEGORY EXEC [PROC_TA_EMPCATEGORY] @local_TODAT,@local_EMPLOYEEID,@local_EMPLOYEECATEGORY
	CREATE TABLE #EMPLOYEENAME(EMPLOYEEID VARCHAR(25))
	CREATE TABLE #EMPLOYEEID(EMPLOYEEID VARCHAR(25))
	
	IF(@local_EMPLOYEEID IS NOT NULL AND @local_EMPLOYEEID <> '')
		BEGIN			
			INSERT INTO #EMPLOYEEID
			SELECT * FROM SPLITUPEMPLOYEECODE(@local_EMPLOYEEID)
		END	
	IF(@local_EMPLOYEENAME IS NOT NULL AND @local_EMPLOYEENAME <> '')
		BEGIN			
			INSERT INTO #EMPLOYEENAME
			SELECT [VALUE] FROM DBO.[SPLITUPEMPLOYEENAME](@local_EMPLOYEENAME,',')
		END	
	INSERT INTO #EMPLEVEL SELECT ELEVEL.EMPLOYEEID,EL.LEVELID,ELEVEL.EFFECTIVEDATE,EMPLOYEE_CODE_ID,SWIPECARDNO  FROM 
	(
		SELECT MAX(EL.EFFECTIVEDATE) AS EFFECTIVEDATE,EL.EMPLOYEEID AS EMPLOYEEID,EMP.EMPLOYEE_CODE_ID,EMP.SWIPECARDNO FROM TA_TBL_EMPLOYEELEVEL EL
		INNER JOIN TA_TBL_EMPLOYEE EMP ON EL.EMPLOYEEID = EMP.EMPLOYEE_ID 
		INNER JOIN #LEVELRIGHTS ON #LEVELRIGHTS.LEVELID=EL.LEVELID
		WHERE  SWIPECARDNO IS NOT NULL AND EMP.ISDELETED=0
		and(@local_GENDER='BOTH' or EMP.GENDER = @local_GENDER)
		and((@ISREPORTINGTO=0 or @local_USERGROUPNAME='Superadmin')or (EMP.EMPLOYEE_ID IN (SELECT * FROM #EMPLOYEEIDS)))
		and(isnull(@local_EMPLOYEEID,'')='' or EMP.Employee_Code_Id in(select * from #EMPLOYEEID))
		and(isnull(@local_EMPLOYEENAME,'')='' or EMP.Employee_Code_Id in(select * from #EMPLOYEENAME))
		GROUP BY EMPLOYEEID,EMPLOYEE_CODE_ID,EMP.SWIPECARDNO
	) ELEVEL
	INNER JOIN TA_TBL_EMPLOYEELEVEL EL ON EL.EFFECTIVEDATE=ELEVEL.EFFECTIVEDATE AND EL.EMPLOYEEID=ELEVEL.EMPLOYEEID
	INNER JOIN #LEVELRIGHTS ON #LEVELRIGHTS.LEVELID=EL.LEVELID
	AND EL.EFFECTIVEDATE <= CONVERT(DATETIME,@local_TODAT, 102) AND EL.LEVELID IS NOT NULL	
	INSERT INTO #TEMPPROCESSEDDATA 
	select #EMPLEVEL.EMPLOYEEID,
			vp.DATE,
			vp.EMPLOYEE_CODE_ID,
			--updated by velumani for Abraj Monthly attendance design issue
			--case when vp.INTIME='00:00' then '' else vp.INTIME end,
			--case when vp.OUTTIME='00:00' then '' else vp.OUTTIME end,
			--vp.SHIFT_ID,
			--case when vp.HRSWORK='00:00' then '' else vp.HRSWORK end,
			(case when  vp.INTIME is null or vp.INTIME='00:00'  then null  else vp.INTIME end) as INTIME,
			(case when  vp.OUTTIME is null or vp.OUTTIME='00:00' then null else vp.OUTTIME end) as OUTTIME,
			vp.SHIFT_ID,
			(case when  vp.HRSWORK is null or vp.HRSWORK='00:00' then null else vp.HRSWORK end) as HRSWORK,
		-------------------------
			vp.WORKHRS,
			vp.STATUS,
			vp.ATTENDANCE,
			vp.ANATTENDANCECODE,
			vp.FNATTENDANCECODE,
			vp.SHIFT_ID,
			vp.PROCESS_REC_ID,
			vp.SHIFT_STARTTIME,
			CAST(vp.SHIFT_SECONDHALF_STARTTIME AS DATETIME)
			,LATEINMINS,
			EARLYOUT,
			LATEIN,
			vp.NORMOT,
			vp.OFFOT,
			vp.HOLOT,
			round(OtMins,0),
			CASE WHEN CHARINDEX('.',CONVERT(VARCHAR(20),EARLYOUTMINS))!=0 THEN CONVERT(INT,SUBSTRING(CONVERT(VARCHAR(20),EARLYOUTMINS),0,CHARINDEX('.',CONVERT(VARCHAR(20),EARLYOUTMINS))))
			ELSE EARLYOUTMINS END,
			OVERTIMESTATUS,
			0,
			INNOTATION,
			OUTNOTATION,
			BREAKHRS,
			LUNCHHRS,
			BREAKHRSINMINS,
			LUNCHHRSINMINS,
			case	when Shift_Id=-1 then vp.ActOffOTMins
					when FNAttendanceCode='Holiday' and ANAttendanceCode='Holiday' then vp.ActHolOTMins
			else ActOTMins end,
			case	when Shift_Id=-1 then vp.ActOffOT
					when FNAttendanceCode='Holiday' and ANAttendanceCode='Holiday' then vp.ActHolOT
			else ActNormOT end,
			vp.SPEC_NormOT1,
			vp.SPEC_NormOTMins1,
			vp.SPEC_NormOT2,
			vp.SPEC_NormOTMins2,
			vp.SPEC_OffOT1,
			vp.SPEC_OffOTMins1,
			vp.SPEC_OffOT2,
			vp.SPEC_OffOTMins2,
			vp.SPEC_HOLOT1,
			vp.SPEC_HOLOTMins1,
			vp.SPEC_HOLOT2,
			vp.SPEC_HOLOTMins2,
			spot.Modified_Spec_NormOTMins1,
			spot.Modified_Spec_NormOTMins2,
			spot.Modified_Spec_OffOTMins1,
			spot.Modified_Spec_OffOTMins2,
			spot.Modified_Spec_HolOTMins1,
			spot.Modified_Spec_HolOTMins2,
			spot.Modified_Spec_NormOTHrs1,
			spot.Modified_Spec_NormOTHrs2,
			spot.Modified_Spec_OffOTHrs1,
			spot.Modified_Spec_OffOTHrs2,
			spot.Modified_Spec_HolOTHrs1,
			spot.Modified_Spec_HolOTHrs2,
			vp.InLocation ,
			vp.OutLocation,
			Vp.In_Latitude,
			Vp.In_Longitude,
			Vp.Out_Latitude,
			Vp.Out_Longitude
	from VW_FetchDataFromProcessedData vp
	INNER JOIN #EMPLEVEL ON #EMPLEVEL.SWIPECARD=vp.EMPLOYEE_CODE_ID  
	Left outer join Ta_tbl_specialOvertimeDetails spot on (vp.Employee_Code_Id=spot.Employee_code_id and vp.Date=spot.Date)
	WHERE vp.ProcessFlag=1 AND (vp.DATE >= CONVERT(DATETIME,CAST( @local_FROMDAT AS NVARCHAR(50)), 102))    
	AND (vp.DATE <= CONVERT(DATETIME,CAST(@local_TODAT AS NVARCHAR(50)), 102)) 
	and (@local_SHIFT=0 or vp.SHIFT_ID=@local_SHIFT)
	and 
	(
		(@local_DATALOADING=0 or 
		((
		(@local_DATALOADING=1 and vp.FNATTENDANCECODE= 'HOLIDAY' AND vp.ANATTENDANCECODE= 'HOLIDAY') or
		(@local_DATALOADING=2 AND ((vp.FNATTENDANCECODE= 'WEEKLY OFF' AND vp.ANATTENDANCECODE= 'WEEKLY OFF') OR (vp.SHIFT_ID= -1)))or
		(@local_DATALOADING=3 AND (((vp.FNATTENDANCECODE= 'WEEKLY OFF' AND vp.ANATTENDANCECODE= 'WEEKLY OFF')OR (vp.SHIFT_ID= -1))
        OR (vp.FNATTENDANCECODE= 'HOLIDAY' AND vp.ANATTENDANCECODE= 'HOLIDAY'))))
		AND ((INTIME IS NOT NULL OR not(INTIME='00:00')) OR (OUTTIME IS NOT NULL OR not(OUTTIME='00:00')))))
			or
		(@local_DATALOADING=4 AND ((vp.FNATTENDANCECODE= 'WEEKLY OFF' AND vp.ANATTENDANCECODE= 'WEEKLY OFF') OR (vp.SHIFT_ID= -1)))
	)
	UPDATE PD SET EXACTSHIFT_STARTTIME=CAST(CONVERT(VARCHAR(25),SHIFT_SECONDHALF_STARTTIME,108) AS DATETIME) FROM #TEMPPROCESSEDDATA PD
	INNER JOIN TA_TBL_PROCESSEDDATA OPD ON PD.PROCESS_REC_ID=OPD.PROCESS_REC_ID WHERE OPD.FNATTENDANCECODE='CL' 	
	------------------------------------------------------CURRENT DATE IS WEEKLY OFF, TO GET THE PREVIOUS DATE SHIFT--------------------------------------------------
	UPDATE #TEMPPROCESSEDDATA SET PREVSHIFT_ID=B.SHIFT_ID FROM #TEMPPROCESSEDDATA T INNER JOIN
	(
		SELECT P.EMPLOYEE_CODE_ID,A.DATE,P.SHIFT_ID FROM TA_TBL_PROCESSEDDATA P INNER JOIN
		(
			SELECT EMPLOYEE_CODE_ID,DATEADD(D,-1,DATE) AS PREVDATE,DATE
			FROM #TEMPPROCESSEDDATA WHERE SHIFT_ID=-1 	
		)
		AS A ON A.EMPLOYEE_CODE_ID=P.EMPLOYEE_CODE_ID AND P.DATE=A.PREVDATE
		WHERE
		(P.DATE >= CONVERT(DATETIME,CAST(@local_FROMDAT AS NVARCHAR(50)), 102))    
		AND (P.DATE <= CONVERT(DATETIME,CAST(@local_TODAT AS NVARCHAR(50)), 102))
	)AS B ON T.EMPLOYEE_CODE_ID=B.EMPLOYEE_CODE_ID AND T.DATE=B.DATE
	--------------------------------------------------------AGAIN THE PREVIOUS DATE IS ALSO WEEKLY OFF MEANS, TO GET THE PREVIOUS DATE SHIFT---------------------------------------------------
	UPDATE #TEMPPROCESSEDDATA SET PREVSHIFT_ID=B.SHIFT_ID FROM #TEMPPROCESSEDDATA T INNER JOIN
	(
		SELECT P.EMPLOYEE_CODE_ID,A.DATE,P.SHIFT_ID FROM TA_TBL_PROCESSEDDATA P INNER JOIN
		(
			SELECT EMPLOYEE_CODE_ID,DATEADD(D,-2,DATE) AS PREVDATE,DATE
			FROM #TEMPPROCESSEDDATA WHERE PREVSHIFT_ID=-1 	
		)
		AS A ON A.EMPLOYEE_CODE_ID=P.EMPLOYEE_CODE_ID AND P.DATE=A.PREVDATE
		WHERE
		(P.DATE >= CONVERT(DATETIME,CAST(@local_FROMDAT AS NVARCHAR(50)), 102))    
		AND (P.DATE <= CONVERT(DATETIME,CAST(@local_TODAT AS NVARCHAR(50)), 102))
	)AS B ON T.EMPLOYEE_CODE_ID=B.EMPLOYEE_CODE_ID AND T.DATE=B.DATE
	------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	UPDATE #TEMPPROCESSEDDATA SET NIGHTORMORN= CASE WHEN SUBSTRING(S.SHIFT_STARTTIME,7,8)='PM' AND SUBSTRING(S.SHIFT_ENDTIME,7,8)='AM' THEN 1 
													WHEN SUBSTRING(S.SHIFT_STARTTIME,7,8)='AM' AND SUBSTRING(S.SHIFT_ENDTIME,7,8)='PM' AND PD.OUTTIME>'00:00 AM' THEN 1
													ELSE 0 END 
	FROM #TEMPPROCESSEDDATA PD INNER JOIN TA_TBL_SHIFT S ON PD.PREVSHIFT_ID=S.SHIFT_ID
	
	DECLARE @TOTALMIN AS INT  
	SET @TOTALMIN = dbo.ConvertHoursToMinites(ISNULL(@local_MINWORKHOURS,'00:00'))
	if(@TOTALMIN='') set @TOTALMIN=0
	
	CREATE TABLE #TEMPMONTHLYATTENDANCE
	(	
		FIRSTSESSION VARCHAR(250),
		SECONDSESSION VARCHAR(250),
		ATTENDANCE VARCHAR(50),
		EMPLOYEE_ID VARCHAR(25),
		EMPNAME VARCHAR(500),
		BRANCHNAME VARCHAR(500),
		DESIGNATION VARCHAR(250),
		DATE DATETIME,
		INTIME VARCHAR(30),
		OUTTIME VARCHAR(30),
		HRSWORK VARCHAR(30),
		SUPPOSEDWORKHOURS VARCHAR(30),
		STATUS VARCHAR(30),
		TOTALMINSWORKED VARCHAR(30),
		SHIFT_SHORTNAME VARCHAR(50),
		SHIFT_TOTALWORKINGHOURS VARCHAR(20),
		GENDER NVARCHAR(10),
		EARLYOUT NVARCHAR(10),
		LATEIN NVARCHAR(10),
		OVERTIME INT,
		NORMOTMIN INT,
		OFFOTMIN INT,
		HOLOTMIN INT,
		NORMOT NVARCHAR(20),
		OFFOT NVARCHAR(20),
		HOLOT NVARCHAR(20),
		LATEINMIN INT,
		EARLYOUTMIN INT,
		TOTDEFWORKHRS INT,
		TOTSUPWORKHRS INT,
		OVERTIMESTATUS VARCHAR(20),
		NIGHTORMORN INT,
		LUNCHINTIME NVARCHAR(20),
		LUNCHOUTTIME NVARCHAR(20)
		,INNOTATION CHAR(1),
		OUTNOTATION CHAR(1)
		,BREAKHOURS VARCHAR(20),
		LUNCHHOURS VARCHAR(20),
		BREAKHOURSMINS INT,
		LUNCHHOURSMINS INT,
		SHIFT_STARTTIME	NVARCHAR(10),
		SHIFT_ENDTIME	NVARCHAR(10),
		CATEGORYNAME 	NVARCHAR(100),
		WEEKDAY_WORKHRS NVARCHAR(100),
		WEEKNUMBER INT,
		FNATTENDANCECODE varchar(100),
		ANATTENDANCECODE varchar(100),
		StatusCode varchar(50),
		-----
		SPEC_NormOT1	varchar(10),
		SPEC_NormOT2	varchar(10),
		SPEC_OffOT1		varchar(10),
		SPEC_OffOT2		varchar(10),
		SPEC_HOLOT1		varchar(10),
		SPEC_HOLOT2		varchar(10)	,	
		InLocation varchar(500),
		OutLocation varchar(500),
		InLatitude varchar(20),
		InLongitude varchar(20),
		OutLatitude varchar(20),
		OutLongitude varchar(20)		
	)	
	INSERT INTO #TEMPMONTHLYATTENDANCE 
	SELECT 
	CASE	WHEN PD.FNATTENDANCECODE='PRESENT' THEN PD.FNATTENDANCECODE + [DBO].[FUNC_TA_ONDUTY](PD.DATE,PD.FNATTENDANCECODE,E.EMPLOYEE_CODE_ID,'FN',SHF.SHIFT_STARTTIME,SHF.SHIFT_SECONDHALF_STARTTIME,SHF.SHIFT_ENDTIME,E.ISFLEXIBLE,SHF.SHIFT_ID,PD.HRSWORK) + CASE  WHEN STATUS IS NULL THEN '' ELSE '(BL)' END 
			ELSE PD.FNATTENDANCECODE
	END + case when INNOTATION='M' then ' #' else '' end AS FIRSTSESSION,
	CASE	WHEN PD.ANATTENDANCECODE ='PRESENT' THEN PD.ANATTENDANCECODE + [DBO].[FUNC_TA_ONDUTY](PD.DATE,PD.ANATTENDANCECODE,E.EMPLOYEE_CODE_ID,'AN',SHF.SHIFT_STARTTIME,SHF.SHIFT_SECONDHALF_STARTTIME,SHF.SHIFT_ENDTIME,E.ISFLEXIBLE,SHF.SHIFT_ID,PD.HRSWORK) + CASE  WHEN STATUS IS NULL THEN '' ELSE '(BL)' END  
			ELSE PD.ANATTENDANCECODE
	END + case when OUTNOTATION='M' then ' #' else '' end AS SECONDSESSION, 
	PD.ATTENDANCE,
	E.EMPLOYEE_CODE_ID AS EMPLOYEE_ID,
	ISNULL(E.EMPLOYEE_FIRSTNAME,'') +  SPACE(1) + ISNULL(E.EMPLOYEE_LASTNAME,'') AS EMPNAME,
	REPLACE(DBO.TA_TBL_LEVELDETAILS.NAME,'&AMP;','&') AS BRANCHNAME,
	REPLACE(T.TITLENAME,'&AMP;','&') AS DESIGNATION,
	CONVERT(VARCHAR(20),PD.DATE,101) AS DATE,
	PD.INTIME,
	PD.OUTTIME,
	PD.HRSWORK,
	CASE	WHEN PD.FNATTENDANCECODE='WEEKLY OFF' AND ANATTENDANCECODE='WEEKLY OFF' THEN	'-' 
			WHEN PD.FNATTENDANCECODE='HOLIDAY'OR ANATTENDANCECODE='HOLIDAY' THEN '-'
			ELSE PD.SUPPOSEDWORKHOURS 
	END 'SUPPOSEDWORKHOURS',
	(PD.ATTENDANCE +  CASE PD.STATUS WHEN 'BL' THEN ' - ' ELSE '' END + ISNULL(PD.STATUS,'')) AS STATUS,
	((SUBSTRING(ISNULL(PD.HRSWORK,'00:00'),0,CHARINDEX(':',PD.HRSWORK))*60) + (SUBSTRING(ISNULL(PD.HRSWORK,'00:00'),(LEN(PD.HRSWORK)-1),2))) AS TOTALMINSWORKED ,
	(CASE WHEN PD.SHIFT_ID='-1' THEN 'WEEKLY OFF' ELSE SHF.SHIFT_SHORTNAME +'('+SHF.Shift_StartTime+'-' +SHF.Shift_EndTime +')' END) AS SHIFT_SHORTNAME ,
	ISNULL
	(
		(
			CASE WHEN ((PD.FNATTENDANCECODE = 'HOLIDAY') OR (PD.ANATTENDANCECODE = 'HOLIDAY')) THEN '-' 
				 WHEN PD.SHIFT_ID=-1 THEN '-'
				 ELSE SHF.SHIFT_TOTALWORKINGHOURS END
		),'00:00'
	) AS SHIFT_TOTALWORKINGHOURS,
	E.GENDER,	
	PD.EARLYOUT,
	PD.LATEIN,
	CASE WHEN PD.NORMOT IS NOT NULL THEN
			CASE	WHEN OVERTIMESTATUS!='Approved' and isnull(ActNormOTmins,0)!=0 then CAST(ActNormOTmins AS VARCHAR(50)) 
					ELSE CAST(OTMINS AS VARCHAR(50)) 
			END
		 WHEN PD.OFFOT IS NOT NULL	THEN
			CASE	WHEN OVERTIMESTATUS!='Approved' and isnull(ActNormOTmins,0)!=0 then CAST(ActNormOTmins AS VARCHAR(50)) 
					ELSE CAST(OTMINS AS VARCHAR(50)) 
			END
		 WHEN PD.HOLOT IS NOT NULL	THEN 
			CASE	WHEN OVERTIMESTATUS!='Approved' and isnull(ActNormOTmins,0)!=0 then CAST(ActNormOTmins AS VARCHAR(50)) 
					ELSE CAST(OTMINS AS VARCHAR(50)) 
			END
		 ELSE 0
	END OVERTIME,
	CASE WHEN ISNULL(NORMOT,'00:00')='00:00' THEN 0 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' and isnull(ActNormOTmins,0)!=0 then CAST(ActNormOTmins AS VARCHAR(50)) 
						ELSE CAST(OTMINS AS VARCHAR(50)) 
				END
	END AS 'NORMOTMINS',
	CASE WHEN ISNULL(OFFOT,'00:00')='00:00'	THEN 0 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' and isnull(ActNormOTmins,0)!=0 then CAST(ActNormOTmins AS VARCHAR(50)) 
						ELSE CAST(OTMINS AS VARCHAR(50)) 
				END
	END AS 'WEEKOFFOTMINS',
	CASE WHEN ISNULL(HOLOT,'00:00')='00:00'	THEN 0 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' and isnull(ActNormOTmins,0)!=0 then CAST(ActNormOTmins AS VARCHAR(50)) 
						ELSE CAST(OTMINS AS VARCHAR(50)) 
				END
	END AS 'HOLIDAYOTMINS',
	CASE WHEN ISNULL(NORMOT,'00:00')='00:00' THEN '00:00' 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' and isnull(ActNormOTmins,0)!=0 then CAST(ActNormOTHrs AS VARCHAR(50)) 
						ELSE CAST(NORMOT AS VARCHAR(50)) 
				END 
	END AS HRSOT,
	CASE WHEN ISNULL(OFFOT,'00:00')='00:00'	THEN '00:00' 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' and isnull(ActNormOTmins,0)!=0 then CAST(ActNormOTHrs AS VARCHAR(50)) 
						ELSE CAST(OFFOT AS VARCHAR(50)) 
				END
	END,
	CASE WHEN ISNULL(HOLOT,'00:00')='00:00'	THEN '00:00' 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' and isnull(ActNormOTmins,0)!=0 then CAST(ActNormOTHrs AS VARCHAR(50)) 
						ELSE CAST(HOLOT AS VARCHAR(50)) 
				END
	END,
	LATEINMIN,
	EARLYOUTMIN,	
	CASE WHEN PD.SHIFT_ID=-1 THEN 0
		 WHEN ((PD.FNATTENDANCECODE = 'HOLIDAY') OR (PD.ANATTENDANCECODE = 'HOLIDAY')) THEN 0
		 ELSE SUBSTRING(SHF.SHIFT_TOTALWORKINGHOURS,0,CHARINDEX(':',SHF.SHIFT_TOTALWORKINGHOURS,0))*60+SUBSTRING(SHF.SHIFT_TOTALWORKINGHOURS,CHARINDEX(':',SHF.SHIFT_TOTALWORKINGHOURS,0)+1,LEN(SHF.SHIFT_TOTALWORKINGHOURS))
	END AS TOTDEFWORKHRS,
	CASE	WHEN PD.SHIFT_ID=-1 THEN 0
			WHEN ((PD.FNATTENDANCECODE = 'HOLIDAY') OR (PD.ANATTENDANCECODE = 'HOLIDAY')) THEN 0
			ELSE SUBSTRING(PD.SUPPOSEDWORKHOURS,0,CHARINDEX(':',PD.SUPPOSEDWORKHOURS,0))*60+SUBSTRING(PD.SUPPOSEDWORKHOURS,CHARINDEX(':',PD.SUPPOSEDWORKHOURS,0)+1,LEN(PD.SUPPOSEDWORKHOURS))
	END AS TOTSUPWORKHRS,
	CASE WHEN OVERTIMESTATUS IS NULL THEN '-' 
		 ELSE OVERTIMESTATUS 
	END,
	NIGHTORMORN,
	'00:00',
	'00:00',
	INNOTATION,
	OUTNOTATION,
	PD.BREAKHOURS,
	LUNCHHOURS,
	BREAKHOURSMINS,
	LUNCHHOURSMINS,
	SHIFT_STARTTIME,
	SHIFT_ENDTIME,
	CATEGORYNAME,
	WEEKDAY_WORKHRS,
	DATEPART(WEEK,DATE),
	FNATTENDANCECODE,
	ANATTENDANCECODE,
	CASE WHEN FNATTENDANCECODE=ANATTENDANCECODE THEN
			CASE	WHEN ANATTENDANCECODE in('Present','Absent','Weekly Off','Holiday') then substring(ANATTENDANCECODE,1,1)
					ELSE ANATTENDANCECODE
			END
		 ELSE 
			CASE	WHEN FNATTENDANCECODE in('Present','Absent','Weekly Off','Holiday') then substring(FNATTENDANCECODE,1,1)
					ELSE FNATTENDANCECODE
			END
			+'/'+
			CASE	WHEN ANATTENDANCECODE in('Present','Absent','Weekly Off','Holiday') then substring(ANATTENDANCECODE,1,1)
					ELSE ANATTENDANCECODE
			END
		END,
	CASE WHEN ISNULL(SPEC_NormOT1,'00:00')='00:00'	THEN '00:00' 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' then CAST(Modified_Spec_NormOTHrs1 AS VARCHAR(50))
						ELSE CAST(SPEC_NormOT1 AS VARCHAR(50)) 
				END
		 END,	
	CASE WHEN ISNULL(SPEC_NormOT2,'00:00')='00:00'	THEN '00:00' 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' then CAST(Modified_Spec_NormOTHrs2 AS VARCHAR(50))
						ELSE CAST(SPEC_NormOT2 AS VARCHAR(50)) 
				END
		 END,
	CASE WHEN ISNULL(SPEC_OffOT1,'00:00')='00:00'	THEN '00:00' 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' then CAST(Modified_Spec_OffOTHrs1 AS VARCHAR(50))
						ELSE CAST(SPEC_OffOT1 AS VARCHAR(50)) 
				END
		 END,
	CASE WHEN ISNULL(SPEC_OffOT2,'00:00')='00:00'	THEN '00:00' 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' then CAST(Modified_Spec_OffOTHrs2 AS VARCHAR(50))
						ELSE CAST(SPEC_OffOT2 AS VARCHAR(50)) 
				END
		 END,
	CASE WHEN ISNULL(SPEC_HOLOT1,'00:00')='00:00'	THEN '00:00' 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' then CAST(Modified_Spec_HolOTHrs1 AS VARCHAR(50))
						ELSE CAST(SPEC_HOLOT1 AS VARCHAR(50)) 
				END
		 END,
	CASE WHEN ISNULL(SPEC_HOLOT2,'00:00')='00:00'	THEN '00:00' 
		 ELSE	CASE	WHEN OVERTIMESTATUS!='Approved' then CAST(Modified_Spec_HolOTHrs2 AS VARCHAR(50))
						ELSE CAST(SPEC_HOLOT2 AS VARCHAR(50)) 
				END
		 END,
	InLocation,
	OutLocation,
	InLatitude ,
	InLongitude ,
	OutLatitude ,
	OutLongitude
	FROM TA_TBL_EMPLOYEE E  
	INNER JOIN #TEMPPROCESSEDDATA PD ON E.EMPLOYEE_ID=PD.EMPAUTOID 
	INNER JOIN #EMPLEVEL ON #EMPLEVEL.EMPLOYEEID = E.EMPLOYEE_ID  
	INNER JOIN TA_TBL_LEVELDETAILS ON #EMPLEVEL.LEVELID = TA_TBL_LEVELDETAILS.ID 
	INNER JOIN #EMPDESIGNATION EDESIG ON EDESIG.EMPLOYEEID = E.EMPLOYEE_ID  
	INNER JOIN TA_TBL_TITLE T ON EDESIG.DESIGNATIONID = T.TITLEID 
	INNER JOIN TA_TBL_GRADE ON TA_TBL_GRADE.GRADE_ID = T.GRADEID 
	LEFT JOIN TA_TBL_SHIFT SHF ON PD.PREVSHIFT_ID = SHF.SHIFT_ID 
	INNER JOIN #EMPTYPE ON #EMPTYPE.EMPLOYEEID = E.EMPLOYEE_ID  
	INNER JOIN #EMPCATEGORY ON #EMPCATEGORY.EMPLOYEEID = E.EMPLOYEE_ID  
	INNER JOIN TA_TBL_CATEGORY CAT ON #EMPCATEGORY.CATEGORYID = CAT.CATEGORYID  
	Left JOIN #EMPPROCESSEDDATA ON #EMPPROCESSEDDATA.PROCESSDATE=PD.DATE AND #EMPPROCESSEDDATA.SWIPECARDNO=PD.EMPLOYEE_CODE_ID
	WHERE E.ISDELETED=0 AND E.REPORT_EXCLUDE=0 AND
	((E.EMPLOYEE_STATUS=1) OR (E.EMPLOYEE_STATUS=0 AND CONVERT(NVARCHAR(11),E.INACTIVEDATE,102)>=CONVERT(NVARCHAR(11),PD.DATE,102)))
	and (@USERGROUPNAME='Superadmin' or TA_TBL_GRADE.GRADE_LEVEL>=@local_GRADELEVEL)
	and (isnull(@local_MINWORKHOURS,'')='' or dbo.ConvertHoursToMinites(isnull(HRSWORK,'00:00'))>=@TOTALMIN)
		
	DECLARE @DATEFORMAT AS INT
	DECLARE @TIMEFORMAT AS NVARCHAR(10)
	SELECT @DATEFORMAT=DATEFORMAT,@TIMEFORMAT=TIMEFORMAT FROM [DBO].[FUNC_TA_GETDATETIMEFORMAT]()
	IF(@EXPORT=0)
	BEGIN
		SELECT	
		EMPLOYEE_ID,
		EMPNAME,
		BRANCHNAME,
		DESIGNATION,
		CASE	WHEN CAST(@DATEFORMAT AS VARCHAR(100))=106 THEN
						REPLACE(CONVERT(VARCHAR, DATE,@DATEFORMAT),' ','-') 
				ELSE CONVERT(VARCHAR, DATE, @DATEFORMAT) END AS DATE,
		CASE WHEN SHIFT_SHORTNAME='WEEKLY OFF' THEN 'OFF' ELSE #TEMPMONTHLYATTENDANCE.SHIFT_SHORTNAME END SHIFT_SHORTNAME,	
		INTIME,
		OUTTIME,
		BREAKHOURS,
		LUNCHHOURS ,	
		HRSWORK,
		LATEIN,
		EARLYOUT,
		NORMOT,
		SPEC_NormOT1,
		SPEC_NormOT2,		
		OFFOT,
		SPEC_OffOT1,
		SPEC_OffOT2,		
		HOLOT,
		SPEC_HOLOT1,
		SPEC_HOLOT2,
		SUPPOSEDWORKHOURS,		
		FIRSTSESSION,
		SECONDSESSION,		
		CONVERT(INT,ISNULL(TOTALMINSWORKED,'0'))TOTALMINSWORKED,
		StatusCode,
		EARLYOUT,
		LATEIN,
		OVERTIME,
		NORMOTMIN,
		OFFOTMIN,
		HOLOTMIN,
		NORMOT,
		OFFOT,
		HOLOT,
		LATEINMIN,
		EARLYOUTMIN,
		TOTDEFWORKHRS,
		TOTSUPWORKHRS,
		OVERTIMESTATUS,
		NIGHTORMORN,
		LUNCHINTIME,
		LUNCHOUTTIME
		,INNOTATION,
		OUTNOTATION,
		
		BREAKHOURSMINS,
		LUNCHHOURSMINS,
		SHIFT_STARTTIME,
		SHIFT_ENDTIME,
		WEEKDAY_WORKHRS,
		WEEKNUMBER ,
		FNATTENDANCECODE,
		ANATTENDANCECODE,
		
		
		DATE processDate,DATEPART(D,DATE) as processDay,left(datename(MONTH,DATE),3) as processMonth
		,'' as Intime1,
		'' as OutTime1,		 
		'' as Intime2,
		'' as OutTime2,
		'' as Intime3,
		'' as OutTime3,
		'' as Intime4,
		'' as OutTime4,
		'' as Intime5,
		'' as OutTime5,
		'' as AcutalWorkedHours,
		MonthNo=CONVERT(varchar(20),datepart(MONTH,DATE))+ ' : ' +left(datename(MONTH,DATE),15)
		FROM #TEMPMONTHLYATTENDANCE ORDER BY EMPLOYEE_ID,CONVERT(datetime,date)
		--processDate added in order clause by mahendren.S
		--Reason: reports showing incorrectly in cross month taking
	END
	else IF(@EXPORT=8)
	BEGIN
		SELECT	
		EMPLOYEE_ID,
		EMPNAME,
		CASE	WHEN CAST(@DATEFORMAT AS VARCHAR(100))=106 THEN
						REPLACE(CONVERT(VARCHAR, DATE,@DATEFORMAT),' ','-') 
				ELSE CONVERT(VARCHAR, DATE, @DATEFORMAT) END AS DATE,
		CASE WHEN SHIFT_SHORTNAME='WEEKLY OFF' THEN 'OFF' ELSE #TEMPMONTHLYATTENDANCE.SHIFT_SHORTNAME END SHIFT_SHORTNAME,	
		INTIME,
		OUTTIME,		
		HRSWORK,
		LATEIN,
		EARLYOUT,
		NORMOT,
		SPEC_NormOT1,
		SPEC_NormOT2,		
		OFFOT,
		SPEC_OffOT1,
		SPEC_OffOT2,		
		HOLOT,
		SPEC_HOLOT1,
		SPEC_HOLOT2,
		SUPPOSEDWORKHOURS,		
		FIRSTSESSION,
		SECONDSESSION,		
		CONVERT(INT,ISNULL(TOTALMINSWORKED,'0'))TOTALMINSWORKED,
		StatusCode,
		EARLYOUT,
		LATEIN,
		OVERTIME,
		NORMOTMIN,
		OFFOTMIN,
		HOLOTMIN,
		NORMOT,
		OFFOT,
		HOLOT,
		LATEINMIN,
		EARLYOUTMIN,
		TOTDEFWORKHRS,
		TOTSUPWORKHRS,
		OVERTIMESTATUS,
		NIGHTORMORN,
		LUNCHINTIME,
		LUNCHOUTTIME
		,INNOTATION,
		OUTNOTATION
		,BREAKHOURS,
		LUNCHHOURS ,
		BREAKHOURSMINS,
		LUNCHHOURSMINS,
		SHIFT_STARTTIME,
		SHIFT_ENDTIME,
		WEEKDAY_WORKHRS,
		WEEKNUMBER ,
		FNATTENDANCECODE,
		ANATTENDANCECODE,
		DESIGNATION,
		BRANCHNAME,
		DATE processDate,DATEPART(D,DATE) as processDay,left(datename(MONTH,DATE),3) as processMonth
		,'' as Intime1,
		'' as OutTime1,		 
		'' as Intime2,
		'' as OutTime2,
		'' as Intime3,
		'' as OutTime3,
		'' as Intime4,
		'' as OutTime4,
		'' as Intime5,
		'' as OutTime5,
		'' as AcutalWorkedHours,
		InLocation,
		OutLocation ,
		InLatitude,
		InLongitude,
		OutLatitude ,
		OutLongitude,
		MonthNo=CONVERT(varchar(20),datepart(MONTH,DATE))+ ' : ' +left(datename(MONTH,DATE),15)
		FROM #TEMPMONTHLYATTENDANCE ORDER BY EMPLOYEE_ID,CONVERT(datetime,date)desc
		--processDate added in order clause by mahendren.S
		--Reason: reports showing incorrectly in cross month taking
	END
	ELSE
	BEGIN
		SELECT	DATE processDate,DATEPART(D,DATE) as processDay,left(datename(MONTH,DATE),3) as processMonth,DENSE_RANK()OVER(ORDER BY EMPLOYEE_ID) AS [SL.NO],
				BRANCHNAME AS LEVEL,
				EMPLOYEE_ID AS [EMPLOYEE ID],
				EMPNAME AS [EMPLOYEE NAME],
				DESIGNATION,
				CATEGORYNAME AS [EMPLOYEE CATEGORY],
				GENDER,
				CASE	WHEN CAST(@DATEFORMAT AS VARCHAR(100))=106 THEN REPLACE(CONVERT(VARCHAR, DATE,@DATEFORMAT),' ','-') 
						ELSE CONVERT(VARCHAR, DATE, @DATEFORMAT) 
				END AS DATE,	
				CASE	WHEN SHIFT_SHORTNAME='WEEKLY OFF' THEN 'OFF' 
						ELSE #TEMPMONTHLYATTENDANCE.SHIFT_SHORTNAME 
				END [SHIFT SHORTNAME],
				INTIME AS [IN TIME],
				OUTTIME AS [OUT TIME],
				HRSWORK AS [HOURS WORKED],	
				SHIFT_TOTALWORKINGHOURS AS [DEFINED WORK HOURS],
				FIRSTSESSION AS [FIRST SESSION],
				SECONDSESSION AS [SECOND SESSION],
				SPEC_NormOT1,
				SPEC_NormOT2,		
				SPEC_OffOT1,
				SPEC_OffOT2,
				SPEC_HOLOT1,
				SPEC_HOLOT2,
				SUPPOSEDWORKHOURS,
				CONVERT(INT,ISNULL(TOTALMINSWORKED,'0'))TOTALMINSWORKED,
				Case when FNATTENDANCECODE in('Present','Present #') then 0.5 else 0.0 end + case when ANATTENDANCECODE in('Present','Present #') then 0.5 else 0.0 end as present,
				Case when FNATTENDANCECODE in('Absent') then 0.5 else 0.0 end + case when ANATTENDANCECODE in('Absent') then 0.5 else 0.0 end as Absent,
				Case when FNATTENDANCECODE in('Weekly Off') then 0.5 else 0.0 end + case when ANATTENDANCECODE IN('Weekly Off') then 0.5 else 0.0 end as WeeklyOff,
				Case when FNATTENDANCECODE in('Holiday','RH') then 0.5 else 0.0 end + case when ANATTENDANCECODE in('Holiday','RH') then 0.5 else 0.0 end as Holiday,
				Case when FNATTENDANCECODE not in('Present','Present #','Absent','Weekly Off','Holiday','RH') then 0.5 else 0.0 end + case when ANATTENDANCECODE not in('Present','Present #','Absent','Weekly Off','Holiday','RH')then 0.5 else 0.0 end as Leave
				,StatusCode,
				EARLYOUT,
				LATEIN,
				OVERTIME,
				NORMOTMIN,
				OFFOTMIN,
				HOLOTMIN,
				NORMOT,
				OFFOT,
				HOLOT,
				LATEINMIN,
				EARLYOUTMIN,
				TOTDEFWORKHRS,
				TOTSUPWORKHRS,
				OVERTIMESTATUS,
				NIGHTORMORN,
				LUNCHINTIME,
				LUNCHOUTTIME
				,INNOTATION,
				OUTNOTATION
				,BREAKHOURS,
				LUNCHHOURS ,
				BREAKHOURSMINS,
				LUNCHHOURSMINS,
				SHIFT_STARTTIME,
				SHIFT_ENDTIME,
				WEEKDAY_WORKHRS,
				WEEKNUMBER ,
				FNATTENDANCECODE,
				ANATTENDANCECODE,
				DESIGNATION,
				BRANCHNAME,DATE processDate
				,'' as Intime1,
				'' as OutTime1,		 
				'' as Intime2,
				'' as OutTime2,
				'' as Intime3,
				'' as OutTime3,
				'' as Intime4,
				'' as OutTime4,
				'' as Intime5,
				'' as OutTime5,
				'' as AcutalWorkedHours,
				MonthNo=CONVERT(varchar(20),datepart(MONTH,DATE))+ ' : ' +left(datename(MONTH,DATE),15)
		FROM #TEMPMONTHLYATTENDANCE ORDER BY EMPLOYEE_ID,MonthNo,WEEKNUMBER
	END	
	
	select EMPLOYEE_ID,
	TotLate_Hours =dbo.ConvertMinsToHours(SUM(isnull(LATEINMIN,0))),
	TotEarlyOut_Hours =dbo.ConvertMinsToHours(SUM(isnull(EARLYOUTMIN,0))),
	TotOT_Hours =dbo.ConvertMinsToHours(SUM(isnull(OVERTIME,0))),
	TotWrk_Hours =dbo.ConvertMinsToHours(SUM(CONVERT(INT,ISNULL(TOTALMINSWORKED,'0')))),
	Prsnt_Days=	SUM(CASE WHEN FNATTENDANCECODE='Present' THEN 0.5 ELSE 0 END)+ 
				SUM(CASE WHEN ANATTENDANCECODE='Present' THEN 0.5 ELSE 0 END), 
	Absnt_Days=	SUM(CASE WHEN FNATTENDANCECODE='Absent' THEN 0.5 ELSE 0 END)+ 
				SUM(CASE WHEN ANATTENDANCECODE='Absent' THEN 0.5 ELSE 0 END) ,
	Wkoff_Days=	SUM(CASE WHEN FNATTENDANCECODE='Weekly Off' THEN 0.5 ELSE 0 END)+ 
				SUM(CASE WHEN ANATTENDANCECODE='Weekly Off' THEN 0.5 ELSE 0 END), 
	H_Days=		SUM(CASE WHEN FNATTENDANCECODE='Holiday' THEN 0.5 ELSE 0 END)+ 
				SUM(CASE WHEN ANATTENDANCECODE='Holiday' THEN 0.5 ELSE 0 END) ,
	LOP_Days=	SUM(CASE WHEN FNATTENDANCECODE='LOP' THEN 0.5 ELSE 0 END)+ 
				SUM(CASE WHEN ANATTENDANCECODE='LOP' THEN 0.5 ELSE 0 END),
	Leave_Days=	SUM(CASE WHEN FNATTENDANCECODE not in('Present','Absent','Weekly off','Holiday','LOP') THEN 0.5 ELSE 0 END)+ 
				SUM(CASE WHEN ANATTENDANCECODE not in('Present','Absent','Weekly off','Holiday','LOP') THEN 0.5 ELSE 0 END),
	Totcalen_Days=DATEDIFF(d,@FROMDAT,@TODAT)	
	FROM #TEMPMONTHLYATTENDANCE
	group by EMPLOYEE_ID order by EMPLOYEE_ID
	
	DROP TABLE #EMPLEVEL  
	DROP TABLE #EMPDESIGNATION  
	DROP TABLE #EMPTYPE  
	DROP TABLE #EMPCATEGORY  
	DROP TABLE #EMPPROCESSEDDATA  
	DROP TABLE #LEVELRIGHTS  
	DROP TABLE #TEMPPROCESSEDDATA  
	DROP TABLE #TEMPEMPLOYEE  
	DROP TABLE #TEMPMONTHLYATTENDANCE	 
END

-----------------------------------------------------------

GO
/****** Object:  StoredProcedure [dbo].[Proc_TA_GetODEntryById]    Script Date: 02-01-2025 13:46:09 ******/
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER ON
GO

--[Proc_TA_GetODEntryById] 16
--select CONVERT(varchar,getdate(),101)
-- Modified by Gopinath on 11 feb 2014 for Datetime conversion
ALTER PROCEDURE [dbo].[Proc_TA_GetODEntryById]
(@ODID as int)
AS
BEGIN
	DECLARE @Isdel int
	SET @Isdel=0
	DECLARE @dateFormat as int
	DECLARE @date as nvarchar(25)
	DECLARE @TimeFormat as nvarchar(25)
	SELECT @date=DateFormat,@TimeFormat=timeformat FROM TA_Tbl_DateandTimeFormat
	IF(@date='dd/MM/yyyy')
	BEGIN
		SET @dateFormat = 103
	END
	ELSE IF(@date='MM/dd/yyyy')
	BEGIN
		SET @dateFormat = 101
	END
	ELSE
	BEGIN
		SET @dateFormat = 106
	END
	--set @TimeFormat='hh:mm'
	select OD.Onduty_ID,
	case	when cast(@dateFormat as varchar(100))=106 then	REPLACE(CONVERT(VARCHAR, Onduty_EntryDate,106),' ','-')
			else convert(varchar, Onduty_EntryDate,@dateFormat)
	end as Onduty_EntryDate,
	case	when cast(@dateFormat as varchar(100))=106 then REPLACE(CONVERT(VARCHAR, Onduty_FromDate,106),' ','-')
			else convert(varchar, Onduty_FromDate,@dateFormat) 
	end as Onduty_FromDate,
	case	when (@TimeFormat)='hh:mm' then CONVERT(varchar(8),DATEADD(minute,0,convert(datetime,OD.Onduty_FromTime,0)), 114) 
			else Onduty_FromTime
	end Onduty_FromTime,
	case	when cast(@dateFormat as varchar(100))=106 then REPLACE(CONVERT(VARCHAR, Onduty_ToDate,106),' ','-')
			else convert(varchar, Onduty_ToDate,@dateFormat) 
	end as Onduty_ToDate,
	case when (@TimeFormat)='hh:mm' then CONVERT(varchar(8), DATEADD(minute,0,convert(datetime,OD.Onduty_ToTime,0)), 114) 
			else Onduty_ToTime
	end Onduty_ToTime
	,OD.Onduty_Reason,OD.Onduty_Status,Onduty_Type,IncludeWeekOff,From_session,To_session,
	E.Employee_FirstName + '' + E.Employee_LastName AS 'Employee_Name',E.Employee_Id,E.Emailid,
	E.Employee_Code_Id,ld.name as LevelName, ld.id as levelid,ED.DesignationID,e.Reporting_To,e.Leave_Sanc_Authority,OD.On_WFH
	FROM TA_Tbl_OndutyEntry as OD 
	INNER JOIN TA_Tbl_Employee as E ON E.Employee_Code_Id=OD.Onduty_EmployeeID
	inner join TA_Tbl_EmployeeLevel el on e.Employee_Id = el.EmployeeId 
	inner join TA_Tbl_EmployeeDesignation ED on e.Employee_Id = ED.EmployeeId   
	inner join Ta_Tbl_levelDetails ld on el.LevelId = ld.id  
	WHERE OD.Isdeleted=@Isdel and OD.Onduty_ID=@ODID
	select * from TA_Tbl_OnDutyConversation where OnDutyApplicationId=@ODID order by OnDutyConversationId desc
END

-----------------------------------------------------------
GO
/****** Object:  StoredProcedure [dbo].[Proc_TA_SelectEmpName]    Script Date: 02-01-2025 13:48:01 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--exec Proc_TA_SelectEmpName @Employee_ID=1,@EmpCode='20',@UserGroupName='SuperAdmin',@GradeLevel='0',@level='0,1',@ParentID=0,@isFrom=N'Onduty'
-- exec Proc_TA_SelectEmpName @Employee_ID=1,@EmpCode='189',@UserGroupName='SuperAdmin',@GradeLevel='0',@level='0,1',@ParentID=0,@isFrom=N''
--Proc_TA_SelectEmpName '100000000000001','SuperAdmin','0','0,21',0                           						
ALTER     PROCEDURE [dbo].[Proc_TA_SelectEmpName] 
(
	@Employee_ID int,
	@EmpCode varchar(50),
	@UserGroupName varchar(250),
	@GradeLevel varchar(20),
	@level varchar(2000),
	@ParentID int,
	@isFrom nvarchar(50)
)
AS    
BEGIN  
	set nocount on
	create table #LevelRights(LevelId int)
	insert into  #LevelRights select * from [dbo].[fn_TA_GetParentChild](@UserGroupName,@ParentID) as LevelId
	declare @isReportingto as int
	select @isReportingto=ReportsBasedOn from TA_Tbl_Usergroup where groupName=@UserGroupName
	create table #EmployeeIds(EmpAutoId int)
    insert into  #EmployeeIds select * from [dbo].[fn_TA_GetMappedEmployees_ReportingTo](@Employee_ID) as EmpAutoId  
    insert into  #EmployeeIds select * from [dbo].[fn_TA_GetMappedEmployees_SancAuthority](@Employee_ID) as EmpAutoId
	DECLARE @sql AS VARCHAR(5000) 
	DECLARE @Isdel int  
	SET @Isdel=0  
	SET @sql ='Select Employee_Id,Employee_FirstName + '' '' + isnull(Employee_LastName,'''') AS ''Employee Name'',TA_Tbl_Employee.CompOff_Eligible,Emailid,Gender' 
	SET @sql = @sql + ' From TA_Tbl_Employee INNER JOIN TA_Tbl_EmployeeDesignation ON TA_Tbl_Employee.Employee_Id = TA_Tbl_EmployeeDesignation.EmployeeId '
	SET @sql = @sql + ' INNER JOIN TA_Tbl_EmployeeLevel ON TA_Tbl_Employee.Employee_Id = TA_Tbl_EmployeeLevel.EmployeeId '
	SET @sql = @sql + ' INNER JOIN TA_Tbl_Title ON TA_Tbl_Title.TitleId=TA_Tbl_EmployeeDesignation.DesignationId '
	SET @sql = @sql + ' INNER JOIN TA_Tbl_Grade ON TA_Tbl_Grade.Grade_ID = TA_Tbl_Title.GradeId '
	SET @sql = @sql + ' INNER JOIN #LevelRights ON #LevelRights.LevelId = TA_Tbl_EmployeeLevel.LevelId '
	SET @sql = @sql + ' WHERE Employee_Code_Id=''' + @EmpCode + ''' '  
	SET @sql = @sql + ' AND  TA_Tbl_Employee.Employee_Code_Id<>''18000000''  AND TA_Tbl_Employee.IsDeleted=''' + cast(@Isdel as nvarchar(20)) + '''  AND TA_Tbl_Employee.Employee_Status=''1'' '
	SET @sql = @sql + ' And TA_Tbl_EmployeeLevel.EffectiveDate = (select top 1 EffectiveDate from TA_Tbl_EmployeeLevel where EmployeeId = ta_tbl_Employee.Employee_Id AND EffectiveDate <=CONVERT(DATETIME,getdate(),102) order by EffectiveDate desc)'
	if(@isReportingto > 0)
            BEGIN
               set @sql = @sql + ' and (TA_Tbl_Employee.Employee_ID IN (select * from #EmployeeIds)) '  
            END
    if(@isFrom='CompOff')
		begin
			set @sql = @sql + ' and TA_Tbl_Employee.CompOff_Eligible=1 and TA_Tbl_Employee.OT_Eligible=0 '  
		end
	if(@UserGroupName<>'SuperAdmin')
		begin
			SET @sql = @sql + ' AND TA_Tbl_Grade.Grade_Level>=' + @GradeLevel + ''
		end
	exec(@sql)
	drop table #LevelRights

	Declare @ActiveYearStartDT nvarchar(100)
	Declare @ActiveYearToDT nvarchar(100)

	Select * From TA_Tbl_YearSetting where IsActive=1

	--Select @ActiveYearStartDT=FromDate,@ActiveYearToDT=ToDate From TA_Tbl_YearSetting where IsActive=1
	--Select * From TA_Tbl_LeaveType

	--Select * From Ta_Tbl_ManualTimeEntry  where 
	Select SUM(IsNull(NOD,0)) As NumWHFDays From TA_Tbl_OndutyEntry where On_WFH in (1,2) and Onduty_EmployeeID=@EmpCode

	Select TA_Tbl_LeaveApplication.Leave_FromDate,TA_Tbl_LeaveApplication.Leave_ToDate,Case when TA_Tbl_LeavePolicyDetails.MaxDays_applicable=NumberOfDays then 'Yes' Else '' End As NumberOfDays  From TA_Tbl_LeaveApplication inner Join TA_Tbl_YearSetting on TA_Tbl_YearSetting.YearSettings_Id=TA_Tbl_LeaveApplication.YearSettings_Id inner join TA_Tbl_LeavePolicyDetails on TA_Tbl_LeavePolicyDetails.LeaveType_Id=TA_Tbl_LeaveApplication.LeaveType_id where Employee_Id=@Employee_ID and TA_Tbl_YearSetting.IsActive=1 and TA_Tbl_LeaveApplication.LeaveType_id In (6)

	--Select * From TA_Tbl_LeavePolicyDetails

	--Alter Table TA_Tbl_OndutyEntry Add On_WFH int,NOD int
	
End
